package ru.ulstu.odin.model.annotation;

import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

import static java.lang.annotation.ElementType.ANNOTATION_TYPE;
import static java.lang.annotation.ElementType.FIELD;

@Retention(RetentionPolicy.RUNTIME)
@Target(value = {FIELD, ANNOTATION_TYPE})
public @interface OdinVisible {
    enum OdinVisibleType {
        ALL, ON_CREATE, ON_UPDATE, NONE;

        @Override
        public String toString() {
            return this.name().toLowerCase();
        }
    }

    OdinVisibleType type() default OdinVisibleType.ALL;
}
